// Code generated by qtc from "create_table.sql.qtpl". DO NOT EDIT.
// See https://github.com/valyala/quicktemplate for details.

//line create_table.sql.qtpl:1
package migrate

//line create_table.sql.qtpl:1
import (
	"gitlab/petstore/config"
	"gitlab/petstore/internal/infrastructure/db/scanner"
)

//line create_table.sql.qtpl:6
import (
	qtio422016 "io"

	qt422016 "github.com/valyala/quicktemplate"
)

//line create_table.sql.qtpl:6
var (
	_ = qtio422016.Copy
	_ = qt422016.AcquireByteBuffer
)

//line create_table.sql.qtpl:6
func StreamCreateTable(qw422016 *qt422016.Writer, table scanner.Table, dbConf config.DB) {
	//line create_table.sql.qtpl:6
	qw422016.N().S(`
create table `)
	//line create_table.sql.qtpl:7
	qw422016.E().S(table.Name)
	//line create_table.sql.qtpl:7
	qw422016.N().S(`
(
	`)
	//line create_table.sql.qtpl:9
	for i, field := range table.Fields {
		//line create_table.sql.qtpl:9
		qw422016.N().S(`
        `)
		//line create_table.sql.qtpl:10
		qw422016.E().S(field.Name)
		//line create_table.sql.qtpl:10
		qw422016.N().S(` `)
		//line create_table.sql.qtpl:10
		qw422016.E().S(field.Type)
		//line create_table.sql.qtpl:10
		qw422016.N().S(` `)
		//line create_table.sql.qtpl:10
		if dbConf.Driver != "ramsql" && dbConf.Driver != "" {
			//line create_table.sql.qtpl:10
			qw422016.E().S(field.Default)
			//line create_table.sql.qtpl:10
		}
		//line create_table.sql.qtpl:10
		if len(table.Fields) != i+1 {
			//line create_table.sql.qtpl:10
			qw422016.N().S(`,`)
			//line create_table.sql.qtpl:10
		}
		//line create_table.sql.qtpl:10
		qw422016.N().S(`
	`)
		//line create_table.sql.qtpl:11
	}
	//line create_table.sql.qtpl:11
	qw422016.N().S(`
);

`)
	//line create_table.sql.qtpl:14
	if len(table.Constraints) > 0 && (dbConf.Driver != "ramsql" && dbConf.Driver != "") {
		//line create_table.sql.qtpl:14
		qw422016.N().S(`
    `)
		//line create_table.sql.qtpl:15
		for _, constraint := range table.Constraints {
			//line create_table.sql.qtpl:15
			qw422016.N().S(`
    create `)
			//line create_table.sql.qtpl:16
			if constraint.Unique {
				//line create_table.sql.qtpl:16
				qw422016.N().S(`unique `)
				//line create_table.sql.qtpl:16
			}
			//line create_table.sql.qtpl:16
			qw422016.N().S(`index `)
			//line create_table.sql.qtpl:16
			qw422016.E().S(table.Name)
			//line create_table.sql.qtpl:16
			qw422016.N().S(`_`)
			//line create_table.sql.qtpl:16
			qw422016.E().S(constraint.Field.Name)
			//line create_table.sql.qtpl:16
			qw422016.N().S(`_idx
     on `)
			//line create_table.sql.qtpl:17
			qw422016.E().S(table.Name)
			//line create_table.sql.qtpl:17
			qw422016.N().S(` (`)
			//line create_table.sql.qtpl:17
			qw422016.E().S(constraint.Field.Name)
			//line create_table.sql.qtpl:17
			qw422016.N().S(`);`)
			//line create_table.sql.qtpl:17
		}
		//line create_table.sql.qtpl:17
		qw422016.N().S(`
`)
		//line create_table.sql.qtpl:18
	}
	//line create_table.sql.qtpl:18
	qw422016.N().S(`
`)
	//line create_table.sql.qtpl:19
	if dbConf.Driver != "ramsql" && dbConf.Driver != "" {
		//line create_table.sql.qtpl:19
		qw422016.N().S(`
    `)
		//line create_table.sql.qtpl:20
		for _, queryOnCreate := range table.Entity.OnCreate() {
			//line create_table.sql.qtpl:20
			qw422016.N().S(`
         `)
			//line create_table.sql.qtpl:21
			qw422016.E().S(queryOnCreate)
			//line create_table.sql.qtpl:21
			qw422016.N().S(`
    `)
			//line create_table.sql.qtpl:22
		}
		//line create_table.sql.qtpl:22
		qw422016.N().S(`
`)
		//line create_table.sql.qtpl:23
	}
	//line create_table.sql.qtpl:23
	qw422016.N().S(`
`)
	//line create_table.sql.qtpl:24
}

//line create_table.sql.qtpl:24
func WriteCreateTable(qq422016 qtio422016.Writer, table scanner.Table, dbConf config.DB) {
	//line create_table.sql.qtpl:24
	qw422016 := qt422016.AcquireWriter(qq422016)
	//line create_table.sql.qtpl:24
	StreamCreateTable(qw422016, table, dbConf)
	//line create_table.sql.qtpl:24
	qt422016.ReleaseWriter(qw422016)
	//line create_table.sql.qtpl:24
}

//line create_table.sql.qtpl:24
func CreateTable(table scanner.Table, dbConf config.DB) string {
	//line create_table.sql.qtpl:24
	qb422016 := qt422016.AcquireByteBuffer()
	//line create_table.sql.qtpl:24
	WriteCreateTable(qb422016, table, dbConf)
	//line create_table.sql.qtpl:24
	qs422016 := string(qb422016.B)
	//line create_table.sql.qtpl:24
	qt422016.ReleaseByteBuffer(qb422016)
	//line create_table.sql.qtpl:24
	return qs422016
	//line create_table.sql.qtpl:24
}
